<script lang="ts">
  import { sortedUniq, sortBy } from "lodash-es";
  import { createEventDispatcher } from "svelte";
  import { defaultSettings, validPlayerCounts } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = defaultSettings;
  export let readonly: boolean = false;

  const handlePlayerCountChange = (evt: Event) => {
    const target = evt.target as HTMLInputElement;
    const value: number = parseInt(target.value);

    const newSettings: GameSettings = target.checked
      ? {
          selectedPlayerCounts: sortedUniq(
            sortBy([...settings.selectedPlayerCounts, value])
          ),
        }
      : {
          selectedPlayerCounts: settings.selectedPlayerCounts.filter(
            (c) => c !== value
          ),
        };

    dispatch("settings_change", newSettings);
  };
</script>

<section>
  <fieldset>
    <legend>Player counts</legend>

    <ul>
      {#each validPlayerCounts as c (c)}
        <li>
          <label class="player-count" for="player-count-{c}">
            <input
              id="player-count-{c}"
              type="checkbox"
              checked={settings.selectedPlayerCounts.includes(c)}
              on:change={handlePlayerCountChange}
              value={c}
              disabled={readonly}
            />
            {c}
          </label>
        </li>
      {/each}
    </ul>
    <ul>
      <li><small>Recommended: 2-4</small></li>
      <li><small>Best: 2</small></li>
    </ul>
  </fieldset>
</section>

<style>
  section {
    padding-bottom: 1rem;
    display: grid;
    row-gap: 1em;
  }

  fieldset {
    border: 0;
    padding: 0;
    margin: 0;
  }
  legend {
    padding: 0;
  }
  ul {
    margin: 0;
    display: flex;
    flex-wrap: wrap;
    column-gap: 1em;
  }
  li {
    white-space: nowrap;
  }

  small {
    filter: opacity(90%);
  }
</style>
